/****************************************************************************
 * (c) 2018 softwareentwicklung-als-prozess.de
 * Dokumentation s. Blog
 * Funktionalitaet:
 * CAN Daten senden
 ***************************************************************************/
// Includes -----------------------------------------------------------------
#include <SPI.h>
#include "mcp_can.h"
#include "can_transm.h"
#include "globals.h"
#include "can_recv_ids_stati.h"

// Defines -----------------------------------------------------------------

// Variablen -----------------------------------------------------------------
const int SPI_CS_PIN = 9;
long unsigned int txID = ID_DISPLAY; 
// Byte 0 und 1: Temperaturwert als ASCII, Byte 2 und 3: Luftfeuchte als ASCII
unsigned char stmp[8] = {50, 48, 49, 48, 0x0, 0x0, 0x0, 0x0};

MCP_CAN CAN(SPI_CS_PIN);                            

// Funktionen ----------------------------------------------------------------
void CAN_Startup(void)
{
  Serial.begin(115200);
  while (CAN_OK != CAN.begin(CAN_250KBPS)) // initialisiere can bus : baudrate = 500k
  {
    Serial.println("CAN BUS Module Initialisierungsfehler");
    Serial.println("Neuer Versuch ....");
    delay(200);
  }    
  Serial.println("CAN BUS Module Initialisiert!");
  Serial.println("Time\t\tPGN\t\tByte0\tByte1\tByte2\tByte3\tByte4\tByte5\tByte6\tByte7");   
}

void CAN_Transmit(void)
{
  Serial.println("In loop");
  txID = ID_DISPLAY;
  // send the data:  id = 0x00, Extended Frame, data len = 8, stmp: data buf, Extended Frame = 1.
  CAN.sendMsgBuf(txID,1, 8, stmp);    
}

void CAN_Transmit_Status(char stat)
{
  // send the data:  id = 0x00, Extended Frame, data len = 1, stmp: data buf
  // Extended Frame = 1.
  txID = ID_STATUS;
  stmp[0] = stat;
  CAN.sendMsgBuf(txID,1, 1, stmp);      
}

void CAN_GetData(void)
{
  Get_Temperatur(&stmp[0]);
  Get_Humidity(&stmp[2]);
}

